import React from 'react';
import { storiesOf } from '@storybook/react';
import { action } from '@storybook/addon-actions';
import IconSettings from '../../icon-settings';
import { VERTICAL_NAVIGATION } from '../../../utilities/constants';
import Default from '../__examples__/default';
import IconExample from '../__examples__/icons';
import NotificationExample from '../__examples__/notifications';
import SnaphotDefault from '../__examples__/snapshot-default';
storiesOf(VERTICAL_NAVIGATION, module).addDecorator(function (getStory) {
  return /*#__PURE__*/React.createElement("div", {
    className: "slds-p-around_medium"
  }, /*#__PURE__*/React.createElement(IconSettings, {
    iconPath: "/assets/icons"
  }, getStory()));
}).add('Default', function () {
  return /*#__PURE__*/React.createElement(Default, {
    action: action
  });
}).add('With icons', function () {
  return /*#__PURE__*/React.createElement(IconExample, {
    action: action
  });
}).add('With notifications', function () {
  return /*#__PURE__*/React.createElement(NotificationExample, {
    action: action
  });
}).add('DOM Snapshot', function () {
  return /*#__PURE__*/React.createElement(SnaphotDefault, null);
});
//# sourceMappingURL=storybook-stories.js.map